# This file was automatically generated by SWIG (http://www.swig.org).
# Version 3.0.12
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info
if _swig_python_version_info >= (2, 7, 0):
    def swig_import_helper():
        import importlib
        pkg = __name__.rpartition('.')[0]
        mname = '.'.join((pkg, '_covariancematrix')).lstrip('.')
        try:
            return importlib.import_module(mname)
        except ImportError:
            return importlib.import_module('_covariancematrix')
    _covariancematrix = swig_import_helper()
    del swig_import_helper
elif _swig_python_version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_covariancematrix', [dirname(__file__)])
        except ImportError:
            import _covariancematrix
            return _covariancematrix
        try:
            _mod = imp.load_module('_covariancematrix', fp, pathname, description)
        finally:
            if fp is not None:
                fp.close()
        return _mod
    _covariancematrix = swig_import_helper()
    del swig_import_helper
else:
    import _covariancematrix
del _swig_python_version_info

try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr(self, class_type, name):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    raise AttributeError("'%s' object has no attribute '%s'" % (class_type.__name__, name))


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except __builtin__.Exception:
    class _object:
        pass
    _newclass = 0

try:
    import weakref
    weakref_proxy = weakref.proxy
except __builtin__.Exception:
    weakref_proxy = lambda x: x


class SwigPyIterator(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, SwigPyIterator, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, SwigPyIterator, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _covariancematrix.delete_SwigPyIterator
    __del__ = lambda self: None

    def value(self) -> "PyObject *":
        return _covariancematrix.SwigPyIterator_value(self)

    def incr(self, n: 'size_t'=1) -> "swig::SwigPyIterator *":
        return _covariancematrix.SwigPyIterator_incr(self, n)

    def decr(self, n: 'size_t'=1) -> "swig::SwigPyIterator *":
        return _covariancematrix.SwigPyIterator_decr(self, n)

    def distance(self, x: 'SwigPyIterator') -> "ptrdiff_t":
        return _covariancematrix.SwigPyIterator_distance(self, x)

    def equal(self, x: 'SwigPyIterator') -> "bool":
        return _covariancematrix.SwigPyIterator_equal(self, x)

    def copy(self) -> "swig::SwigPyIterator *":
        return _covariancematrix.SwigPyIterator_copy(self)

    def next(self) -> "PyObject *":
        return _covariancematrix.SwigPyIterator_next(self)

    def __next__(self) -> "PyObject *":
        return _covariancematrix.SwigPyIterator___next__(self)

    def previous(self) -> "PyObject *":
        return _covariancematrix.SwigPyIterator_previous(self)

    def advance(self, n: 'ptrdiff_t') -> "swig::SwigPyIterator *":
        return _covariancematrix.SwigPyIterator_advance(self, n)

    def __eq__(self, x: 'SwigPyIterator') -> "bool":
        return _covariancematrix.SwigPyIterator___eq__(self, x)

    def __ne__(self, x: 'SwigPyIterator') -> "bool":
        return _covariancematrix.SwigPyIterator___ne__(self, x)

    def __iadd__(self, n: 'ptrdiff_t') -> "swig::SwigPyIterator &":
        return _covariancematrix.SwigPyIterator___iadd__(self, n)

    def __isub__(self, n: 'ptrdiff_t') -> "swig::SwigPyIterator &":
        return _covariancematrix.SwigPyIterator___isub__(self, n)

    def __add__(self, n: 'ptrdiff_t') -> "swig::SwigPyIterator *":
        return _covariancematrix.SwigPyIterator___add__(self, n)

    def __sub__(self, *args) -> "ptrdiff_t":
        return _covariancematrix.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self
SwigPyIterator_swigregister = _covariancematrix.SwigPyIterator_swigregister
SwigPyIterator_swigregister(SwigPyIterator)

SHARED_PTR_DISOWN = _covariancematrix.SHARED_PTR_DISOWN
import CosmoBolognaLib
class CovarianceMatrix_TwoPointCorrelation1D_monopole(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CovarianceMatrix_TwoPointCorrelation1D_monopole, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CovarianceMatrix_TwoPointCorrelation1D_monopole, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _covariancematrix.new_CovarianceMatrix_TwoPointCorrelation1D_monopole(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _covariancematrix.delete_CovarianceMatrix_TwoPointCorrelation1D_monopole
    __del__ = lambda self: None

    def compute_terms(self, output_dir: 'std::string const', compute_RR: 'bool const'=True, compute_C4: 'bool const'=True, compute_C3: 'bool const'=True, compute_C2: 'bool const'=True, tcount: 'bool const'=False) -> "void":
        return _covariancematrix.CovarianceMatrix_TwoPointCorrelation1D_monopole_compute_terms(self, output_dir, compute_RR, compute_C4, compute_C3, compute_C2, tcount)

    def __call__(self, alpha: 'double const') -> "cbl::data::CovarianceMatrix":
        return _covariancematrix.CovarianceMatrix_TwoPointCorrelation1D_monopole___call__(self, alpha)
CovarianceMatrix_TwoPointCorrelation1D_monopole_swigregister = _covariancematrix.CovarianceMatrix_TwoPointCorrelation1D_monopole_swigregister
CovarianceMatrix_TwoPointCorrelation1D_monopole_swigregister(CovarianceMatrix_TwoPointCorrelation1D_monopole)

class CovarianceMatrix_TwoPointCorrelation_multipoles(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, CovarianceMatrix_TwoPointCorrelation_multipoles, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, CovarianceMatrix_TwoPointCorrelation_multipoles, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _covariancematrix.new_CovarianceMatrix_TwoPointCorrelation_multipoles(*args)
        try:
            self.this.append(this)
        except __builtin__.Exception:
            self.this = this
    __swig_destroy__ = _covariancematrix.delete_CovarianceMatrix_TwoPointCorrelation_multipoles
    __del__ = lambda self: None

    def compute_terms(self, output_dir: 'std::string const', compute_RR: 'bool const'=True, compute_C4: 'bool const'=True, compute_C3: 'bool const'=True, compute_C2: 'bool const'=True, tcount: 'bool const'=False) -> "void":
        return _covariancematrix.CovarianceMatrix_TwoPointCorrelation_multipoles_compute_terms(self, output_dir, compute_RR, compute_C4, compute_C3, compute_C2, tcount)

    def __call__(self, alpha: 'double const') -> "cbl::data::CovarianceMatrix":
        return _covariancematrix.CovarianceMatrix_TwoPointCorrelation_multipoles___call__(self, alpha)
CovarianceMatrix_TwoPointCorrelation_multipoles_swigregister = _covariancematrix.CovarianceMatrix_TwoPointCorrelation_multipoles_swigregister
CovarianceMatrix_TwoPointCorrelation_multipoles_swigregister(CovarianceMatrix_TwoPointCorrelation_multipoles)

# This file is compatible with both classic and new-style classes.


